import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _objectSpread from "@babel/runtime/helpers/objectSpread";

/**************************************************
 * Created by nanyuantingfeng on 23/08/2017 17:19.
 **************************************************/
import { HotModuleReplacementPlugin } from './plugins';
import getStats from './getStats';
var DEFAULT_PORT = 8080;
var DEFAULT_HOST = '0.0.0.0';

function parseProxyWithOptions(proxy, options) {
  var oo = {};
  var keys = Object.keys(proxy);
  keys.forEach(function (key) {
    var target = proxy[key];
    oo[key] = typeof target === 'string' ? _objectSpread({
      target: target
    }, options) : _objectSpread({}, target, options);
  });
  return oo;
}

function parseStringProxy(proxy) {
  if (typeof proxy === 'string') {
    proxy = {
      '*': proxy
    };
  }

  return proxy;
}

export default function mwDevServer(_x, _x2) {
  return _mwDevServer.apply(this, arguments);
}

function _mwDevServer() {
  _mwDevServer = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee(context, next) {
    var devServer, proxy, proxyOptions, plugins, DIRs, packageMap, proxyObj;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.devServer = {};
            context.proxy = {};
            context.proxyOptions = {
              changeOrigin: true
            };
            context.isDevServer = true;
            next();
            devServer = context.devServer, proxy = context.proxy, proxyOptions = context.proxyOptions, plugins = context.plugins, DIRs = context.DIRs, packageMap = context.packageMap;
            proxyObj = parseProxyWithOptions(_objectSpread({}, parseStringProxy(packageMap.proxy), proxy), proxyOptions); // @ts-ignore

            context.webpackConfig.devServer = context.devServer = _objectSpread({
              port: context.port || DEFAULT_PORT,
              host: DEFAULT_HOST,
              hot: true,
              hotOnly: true,
              contentBase: DIRs.root,
              // By default files from `contentBase` will not trigger a page reload.
              watchContentBase: false,
              // Enable gzip compression of generated files.
              compress: true,
              // WebpackDevServer is noisy by default so we emit custom message instead
              // by listening to the compiler events with `compiler.hooks[...].tap` calls above.
              quiet: false,
              disableHostCheck: true,
              clientLogLevel: 'none',
              overlay: false,
              headers: {
                'Access-Control-Allow-Origin': '*'
              },
              historyApiFallback: {
                // Paths with dots should still use the history fallback.
                // See https://github.com/facebook/create-react-app/issues/387.
                disableDotRule: true
              },
              proxy: proxyObj,
              stats: getStats(false)
            }, devServer);
            plugins.push(new HotModuleReplacementPlugin());

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _mwDevServer.apply(this, arguments);
}