import _regeneratorRuntime from "@babel/runtime/regenerator";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";

/**************************************************
 * Created by nanyuantingfeng on 27/10/2017 16:25.
 **************************************************/
import CaseSensitivePathsPlugin from 'case-sensitive-paths-webpack-plugin';
import OptimizeCSSAssetsPlugin from 'optimize-css-assets-webpack-plugin';
import { BundleAnalyzerPlugin } from 'webpack-bundle-analyzer';
import LodashWebpackPlugin from 'lodash-webpack-plugin';
import TerserPlugin from 'terser-webpack-plugin';
import path from 'path';
import { ProgressPlugin, IgnorePlugin, AggressiveSplittingPlugin } from './plugins';
import { getProgressHandler, getOptions } from './util';
export default function mwPlugins(_x, _x2) {
  return _mwPlugins.apply(this, arguments);
}

function _mwPlugins() {
  _mwPlugins = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee(context, next) {
    var compress, plugins, dll, ENV, _context$aggressive, aggressive, __IS_BUILD_LIBRARY__, optimization, cwd, outputPath, _context$records, records, _context$analyzer, analyzer, _context$optimizeLoda, optimizeLodash;

    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.plugins = [new CaseSensitivePathsPlugin(), new ProgressPlugin(getProgressHandler), new IgnorePlugin(/^\.\/locale$/, /moment$/)];
            next();
            compress = context.compress, plugins = context.plugins, dll = context.dll, ENV = context.ENV, _context$aggressive = context.aggressive, aggressive = _context$aggressive === void 0 ? false : _context$aggressive, __IS_BUILD_LIBRARY__ = context.__IS_BUILD_LIBRARY__, optimization = context.optimization;
            context.webpackConfig.optimization = context.webpackConfig.optimization || {};

            if (!Array.isArray(dll)) {
              context.webpackConfig.optimization = _objectSpread({
                splitChunks: {
                  chunks: 'all',
                  name: false
                },
                // Keep the runtime chunk seperated to enable long term caching
                // https://twitter.com/wSokra/status/969679223278505985
                runtimeChunk: !__IS_BUILD_LIBRARY__,
                //common
                removeAvailableModules: true,
                removeEmptyChunks: true,
                mergeDuplicateChunks: true,
                // must be false
                sideEffects: false,
                //
                flagIncludedChunks: true,
                occurrenceOrder: true,
                concatenateModules: true,
                //
                usedExports: true,
                providedExports: true,
                noEmitOnErrors: true,
                namedModules: ENV.isDevelopment,
                namedChunks: ENV.isDevelopment
              }, optimization);

              if (aggressive) {
                plugins.push(new AggressiveSplittingPlugin(getOptions(aggressive)));
              }
            }

            context.webpackConfig.optimization.minimize = !!compress;

            if (compress) {
              context.webpackConfig.optimization.minimizer = [new TerserPlugin({
                terserOptions: {
                  parse: {
                    // we want terser to parse ecma 8 code. However, we don't want it
                    // to apply any minfication steps that turns valid ecma 5 code
                    // into invalid ecma 5 code. This is why the 'compress' and 'output'
                    // sections only apply transformations that are ecma 5 safe
                    // https://github.com/facebook/create-react-app/pull/4234
                    ecma: 8
                  },
                  compress: {
                    // @ts-ignore
                    ecma: 5,
                    warnings: false,
                    // Disabled because of an issue with Uglify breaking seemingly valid code:
                    // https://github.com/facebook/create-react-app/issues/2376
                    // Pending further investigation:
                    // https://github.com/mishoo/UglifyJS2/issues/2011
                    comparisons: false,
                    // Disabled because of an issue with Terser breaking valid code:
                    // https://github.com/facebook/create-react-app/issues/5250
                    // Pending futher investigation:
                    // https://github.com/terser-js/terser/issues/120
                    inline: 2
                  },
                  mangle: {
                    safari10: true
                  },
                  output: {
                    ecma: 5,
                    comments: false,
                    // Turned on because emoji and regex is not minified properly using default
                    // https://github.com/facebook/create-react-app/issues/2488
                    ascii_only: true
                  }
                },
                // Use multi-process parallel running to improve the build speed
                // Default number of concurrent runs: os.cpus().length - 1
                parallel: true,
                // Enable file caching
                cache: true,
                sourceMap: false
              }), new OptimizeCSSAssetsPlugin({
                cssProcessorOptions: {
                  map: false
                }
              })];
            }

            cwd = context.cwd, outputPath = context.outputPath, _context$records = context.records, records = _context$records === void 0 ? false : _context$records, _context$analyzer = context.analyzer, analyzer = _context$analyzer === void 0 ? false : _context$analyzer, _context$optimizeLoda = context.optimizeLodash, optimizeLodash = _context$optimizeLoda === void 0 ? true : _context$optimizeLoda;
            context.plugins = plugins;

            if (records) {
              context.webpackConfig.recordsOutputPath = path.join(cwd, outputPath, getOptions(records, 'records.json'));
            }

            if (analyzer) {
              plugins.push(new BundleAnalyzerPlugin(getOptions(analyzer)));
            }

            if (optimizeLodash) {
              plugins.push(new LodashWebpackPlugin(getOptions(optimizeLodash, {
                shorthands: true,
                paths: true,
                cloning: true,
                flattening: true,
                exotics: true,
                collections: true,
                caching: true
              })));
            }

          case 12:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _mwPlugins.apply(this, arguments);
}